USE [msdb]
GO

/****** Object:  Job [ASLB_CheckASAvailability]    Script Date: 04/22/2009 13:00:34 ******/
IF  EXISTS (SELECT job_id FROM msdb.dbo.sysjobs_view WHERE name = N'ASLB_CheckASAvailability')
EXEC msdb.dbo.sp_delete_job @Job_Name =N'ASLB_CheckASAvailability', @delete_unused_schedule=1
GO

USE [msdb]
GO

/****** Object:  Job [ASLB_CheckASAvailability]    Script Date: 04/22/2009 13:00:34 ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]]    Script Date: 04/22/2009 13:00:34 ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'ASLB_CheckASAvailability', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Execute MonitorASAvailability]    Script Date: 04/22/2009 13:00:35 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Execute MonitorASAvailability', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=1, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'SET CONTEXT_INFO $(ESCAPE_NONE(JOBID)) 

DECLARE @err int, @comment varchar(7000), @ErrSeverity int 
DECLARE @mirroring_role tinyint, @mirroring_state_desc nvarchar(60), @mirroring_role_desc nvarchar(60)

WHILE (1=1)
BEGIN
SELECT @mirroring_role = mirroring_role, @mirroring_state_desc = mirroring_state_desc, @mirroring_role_desc = mirroring_role_desc
FROM sys.database_mirroring dm
JOIN sys.databases db
ON db.database_id = dm.database_id 
WHERE db.name = ''ASLB''

IF @mirroring_role = 1 OR @mirroring_role IS NULL--PRINCIPAL
BEGIN
BEGIN TRY 
EXEC ASLB.dbo.MonitorASAvailability 
END TRY
BEGIN CATCH
SELECT @err = ERROR_NUMBER(), @comment = ERROR_MESSAGE(), @ErrSeverity = ERROR_SEVERITY()
SET @comment = @comment + '' Error Severity: '' + CAST(@ErrSeverity AS varchar(25))
RAISERROR(@comment, 18,127)
END CATCH
END

WAITFOR DELAY ''00:00:20'' --wait for 20 seconds and run again 
END', 
		@database_name=N'master', 
		@output_file_name=N'C:\Program Files\Microsoft SQL Server\MSSQL10.MSSQLSERVER\MSSQL\ASLB_CheckASAvailability.txt', 
		@flags=2
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Recurring', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=2, 
		@freq_subday_interval=15, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20090413, 
		@active_end_date=99991231, 
		@active_start_time=0, 
		@active_end_time=235959, 
		@schedule_uid=N'baa3e39c-c6ef-4a58-af11-7b97527eca51'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO


