USE [dmv]
GO

/****** Object:  Table [stage].[SSASDMVSession]    Script Date: 12/23/2008 13:55:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[stage].[SSASDMVSession]') AND type in (N'U'))
DROP TABLE [stage].[SSASDMVSession]
GO

/****** Object:  Table [stage].[SSASDMVSession]    Script Date: 12/23/2008 13:55:37 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [stage].[SSASDMVSession](
	[SESSION_ID] [nvarchar](50) NULL,
	[SESSION_SPID] [int] NULL,
	[SESSION_CONNECTION_ID] [int] NULL,
	[SESSION_USER_NAME] [ntext] NULL,
	[SESSION_CURRENT_DATABASE] [ntext] NULL,
	[SESSION_USED_MEMORY] [int] NULL,
	[SESSION_PROPERTIES] [ntext] NULL,
	[SESSION_START_TIME] [datetime] NULL,
	[SESSION_ELAPSED_TIME_MS] [numeric](20, 0) NULL,
	[SESSION_LAST_COMMAND_START_TIME] [datetime] NULL,
	[SESSION_LAST_COMMAND_END_TIME] [datetime] NULL,
	[SESSION_LAST_COMMAND_ELAPSED_TIME_MS] [numeric](20, 0) NULL,
	[SESSION_IDLE_TIME_MS] [numeric](20, 0) NULL,
	[SESSION_CPU_TIME_MS] [numeric](20, 0) NULL,
	[SESSION_LAST_COMMAND] [ntext] NULL,
	[SESSION_LAST_COMMAND_CPU_TIME_MS] [numeric](20, 0) NULL,
	[SESSION_STATUS] [int] NULL,
	[SESSION_READS] [numeric](20, 0) NULL,
	[SESSION_WRITES] [numeric](20, 0) NULL,
	[SESSION_READ_KB] [numeric](20, 0) NULL,
	[SESSION_WRITE_KB] [numeric](20, 0) NULL,
	[SESSION_COMMAND_COUNT] [int] NULL,
	[Instance_Name] [nvarchar](255) NULL,
	[CurrentDate] [datetime] NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

/****** Object:  Index [IX_stage.SSASDMVSession]    Script Date: 12/23/2008 13:55:43 ******/
IF  EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[stage].[SSASDMVSession]') AND name = N'IX_stage.SSASDMVSession')
DROP INDEX [IX_stage.SSASDMVSession] ON [stage].[SSASDMVSession] WITH ( ONLINE = OFF )
GO

/****** Object:  Index [IX_stage.SSASDMVSession]    Script Date: 12/23/2008 13:55:43 ******/
CREATE NONCLUSTERED INDEX [IX_stage.SSASDMVSession] ON [stage].[SSASDMVSession] 
(
	[SESSION_ID] ASC,
	[Instance_Name] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

